DebuggableScript (rhino 1.7.7.2 API)
Date: 2017-09-27

org.mozilla.javascript.debug

## Interface DebuggableScript

-     public interface DebuggableScript

  This interface exposes debugging information from executable code (either functions or top-level scripts).

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `DebuggableScript` | `getFunction(int index)`
    `int` | `getFunctionCount()`
    `java.lang.String` | `getFunctionName()` Get name of the function described by this script.
    `int[]` | `getLineNumbers()` Get array containing the line numbers that that can be passed to `DebugFrame.onLineChange()`.``
    `int` | `getParamAndVarCount()` Get number of declared parameters and local variables.
    `int` | `getParamCount()` Get number of declared parameters in the function.
    `java.lang.String` | `getParamOrVarName(int index)` Get name of a declared parameter or local variable.
    `DebuggableScript` | `getParent()`
    `java.lang.String` | `getSourceName()` Get the name of the source (usually filename or URL) of the script.
    `boolean` | `isFunction()` Returns true if this is a function, false if it is a script.
    `boolean` | `isGeneratedScript()` Returns true if this script or function were runtime-generated from JavaScript using `eval` function or `Function` or `Script` constructors.
    `boolean` | `isTopLevel()`

- - ### Method Detail

    - #### isTopLevel

          boolean isTopLevel()

    - #### isFunction

          boolean isFunction()

      Returns true if this is a function, false if it is a script.

    - #### getFunctionName

          java.lang.String getFunctionName()

      Get name of the function described by this script. Return null or an empty string if this script is not a function.

    - #### getParamCount

          int getParamCount()

      Get number of declared parameters in the function. Return 0 if this script is not a function.
      See Also:
        `getParamAndVarCount()`, `getParamOrVarName(int index)`

    - #### getParamAndVarCount

          int getParamAndVarCount()

      Get number of declared parameters and local variables. Return number of declared global variables if this script is not a function.
      See Also:
        `getParamCount()`, `getParamOrVarName(int index)`

    - #### getParamOrVarName

          java.lang.String getParamOrVarName(int index)

      Get name of a declared parameter or local variable. `index` should be less then `getParamAndVarCount()`. If `index < `getParamCount()``, return the name of the corresponding parameter, otherwise return the name of variable. If this script is not function, return the name of the declared global variable.

    - #### getSourceName

          java.lang.String getSourceName()

      Get the name of the source (usually filename or URL) of the script.

    - #### isGeneratedScript

          boolean isGeneratedScript()

      Returns true if this script or function were runtime-generated from JavaScript using `eval` function or `Function` or `Script` constructors.

    - #### getLineNumbers

          int[] getLineNumbers()

      Get array containing the line numbers that that can be passed to `DebugFrame.onLineChange()`. Note that line order in the resulting array is arbitrary``

    - #### getFunctionCount

          int getFunctionCount()

    - #### getFunction

          DebuggableScript getFunction(int index)

    - #### getParent

          DebuggableScript getParent()